gmtset ANNOT_FONT_PRIMARY Helvetica  HEADER_FONT_SIZE 16p HEADER_OFFSET -0.04c
gmtset ANNOT_FONT_SIZE 11p LABEL_FONT_SIZE 12p
gmtset ANNOT_OFFSET 0.1c LABEL_OFFSET 0.05c
gmtset INPUT_DATE_FORMAT yyyy-mm-dd
gmtset TIME_FORMAT_PRIMARY abbreviated CHAR_ENCODING ISOLatin1+
gmtset GRID_PEN_PRIMARY thin,--   TICK_LENGTH -0.125c BASEMAP_TYPE plain

topo=../inp_files/ETOPO1_Bed_g_gmt4.grd
trench=../inp_files/trench.gmt
cpt0=../inp_files/by.cpt
inp0=../inp_files/query_all_time
inpg=../inp_files/allmt_time

cpt=topo.cpt
makecpt -T-10000/6000/100 -Cgray -D -Z > $cpt
grd=mytopo.grd
norm=mytopo.norm
cptd=dep.cpt
makecpt -T-100/700/10 -Cjet -D -Z -I > $cptd

mag1=$1
mag2=$2
dist0=$3
dist10=`echo $dist0 | awk '{printf("%04d",$1)}'`
dd0=$4
inp=$5

fig0=M${mag1}_M${mag2}_D${dist10}km_T${dd0}_sequence
nseq=`awk 'NR==2 {print $1}' $inp`
echo "**** ", $nseq
t1=`echo $dd0 | awk '{print -$1-1}'`
t2=10
dist=$3
kseq=1
mag3=3.25
lat11=`awk 'NR>1 {print $6}' $inp | sort -n -k 1 | awk 'NR==1 {print $1-2}' | awk '{if($1<=-88) print "-88"; else print $1}'`
lat22=`awk 'NR>1 {print $6}' $inp | sort -n -rk 1 | awk 'NR==1 {print $1+5}' | awk '{if($1>=88) print "88"; else print $1}'`
echo " ******* lat1= " $lat11 "lat22 = " $lat22
echo $lat11 $lat22
for ii in `seq 1 $nseq`
do
    iseq=`echo $ii $nseq | awk '{print $2-$1+1}'`
    ievt=`awk -v i=$iseq '$1==i {print $2}' $inp | sort -n -rk 1 | awk 'NR==1 {print $1}'`
    tim=`awk -v i=$iseq '$1==i && $2==1 {print substr($3,1,4)}' $inp`
    evlat=`awk -v i=$iseq '$1==i && $2==1 {print $6}' $inp`
    evlon=`awk -v i=$iseq '$1==i && $2==1 {print $5}' $inp`
    evdep=`awk -v i=$iseq '$1==i && $2==1 {print $7}' $inp`
    magg=`awk -v i=$iseq '$1==i && $2==1 {print $8}' $inp`
    nam=`awk -v i=$iseq '$1==i && $2==1 {print $18}' $inp`
    dist1=`echo $magg | awk '{print 10**(-2.44+0.59*$1)*2}'`
    distd=`echo $length1 | awk '{print $1*2}'`
    tt=`awk -v i=$iseq '$1==i && $2==1 {print $17}' $inp`
    dt0=`awk -v i=$iseq '$1==i {print $16}' $inp | sort -n -rk 1 | awk 'NR==1 {print -$1}'`
    tt1=`echo $tt $t1 | awk '{print $1+$2}'`
    tt2=`echo $tt $t2 | awk '{print $1+$2}'`
    awk -v s=$tt1 -v t=$tt2 '$6>=s && $6<=t {print $0}' $inp0 > tmp
    nn=`wc tmp | awk '{print $1}'`
    echo $evlat $evlon $evdep $tt1 $tt2
../inp_files/sel_seq << EOD
tmp $nn
$evlat $evlon $evdep $dist
EOD
   inp1=${iseq}_seq_sel
   mv seq_sel $inp1

fig=${iseq}_seq_sel
lat10=`sort -n -k 2 $inp1 | awk 'NR==1 {print $2-0.2}'`
lat20=`sort -n -rk 2 $inp1 | awk 'NR==1 {print $2+0.2}'`
lon10=`sort -n -k 3 $inp1 | awk 'NR==1 {print $3-0.3}'`
lon20=`sort -n -rk 3 $inp1 | awk 'NR==1 {print $3+0.3}'`
echo $lat10 $lat20 $lon10 $lon20
lat1=`echo $evlat $dist0 $lat10 | awk '{if($1-$2/150<=$3) print $1-$2/150; else print $3}' | awk '{if($1<=-85) print "-85"; else print $1}'`
lat2=`echo $evlat $dist0 $lat20 | awk '{if($1+$2/150>=$3) print $1+$2/150; else print $3}' | awk '{if($1>=85) print "85";else print $1}'`
lon1=`echo $evlon $dist0 $lon10 | awk '{if($1-$2/150<=$3) print $1-$2/150; else print $3}' | awk '{if($1<=0) print "0"; else print $1}'`
lon2=`echo $evlon $dist0 $lon20 | awk '{if($1+$2/150>=$3) print $1+$2/150; else print $3}' | awk '{if($1>=360) print "360"; else print $1}'`
ddx=`echo $lon2 $lon1 | awk '{print $1-$2}' | awk '{if($1<1.8) print "ddd.x"; else print "ddd"}'`
sam=`echo $lon2 $lon1 | awk '{print $1-$2}' | awk '{if($1<=1.1) print "15"; else if ($1<=2) print "30"; else if ($1<=4) print "60"; else if ($1<=7) print "120"; else print "240"}'`
xlb1=`echo $lon2 $lon1 | awk '{print $1-$2}' | awk '{if($1<1.0) print "0.2";  else if ($1<=2.1) print "0.5";  else if ($1<=5) print "1"; else print int(($1+1)/3)}'`
xlb2=`echo $xlb1 | awk '{print $1/2}'`
Rvalue=${lon1}/${lon2}/${lat1}/${lat2}
echo $Rvalue
scale0=`echo $lon2 $lon1 $lat2 $lat1 | awk '{if($1-$2>($3-$4)) print "3.75"; else print 3.75/($3-$4)*($1-$2)}'`
scale=`echo $scale0 $lat1 $lat2 $lon1 $lon2 | awk '{if($2<=-45 || $3>=45) print $1/($3-$2)*($5-$4)/1.25; else if($2<=-60 || $3>=60) print $1/2.0/($3-$2)*($5-$4); else print $1}' | awk '{if($1>3.75) print "3.75"; else print $1}'`

    grdsample  $topo -I${sam}c -R$Rvalue -G$grd -fg
    grdgradient $grd -G$norm -A10000 -M -Nt1
    gmtset TICK_LENGTH -0.125c PLOT_DEGREE_FORMAT $ddx
    gmtset ANNOT_FONT_SIZE 14p LABEL_FONT_SIZE 14p

awk -v t=$tt1 -v s=$tt2 -v a=$lon1 -v b=$lon2 -v c=$lat1 -v d=$lat2 '$16>=t && $16<=(s+0.00012) && $1>=a && $1<=b && $2>=c && $2<=d {print $0}' $inpg > gcmt_$i

    grdimage -JM${scale}i -Ba${xlb1}f${xlb2}WSne:."#${iseq}, $tim M$magg, $nam": -R${Rvalue} -X0.65i -Y1.5i -C$cpt $grd -I$norm -K > $fig.ps
    pscoast -R -J -O -K -W0.5p/0/50/0 -Df -N1 >> $fig.ps
    psxy -R -J -O -K -M $trench -W1p/255/0/255t3:3_0 >> $fig.ps
    dd0=`echo $dist0 | awk '{print $1*2}'`
    echo $evlon $evlat 0 $dd0 $dd0 | psxy -R -J -O -K -SE -W0.75p/55/55/55t3:3_0 >> $fig.ps
    dep10=`awk -v m=$mag3 '$5>=m {print $4}' $inp1 | sort -n -k 1 | awk 'NR==1 {print $1}'`
    dep20=`awk -v m=$mag3 '$5>=m {print $4}' $inp1 | sort -n -rk 1 | awk 'NR==1 {print $1}'`
    dep1=`echo $dep20 $dep10 | awk '{if(($1-$2)<=3) print $2-1 ; else if(($1-$2)<=10) print $2-2; else print $2-($1-$2)*0.01}' | awk '{if($1>=1) print int($1-1); else print "0"}'`
    dep2=`echo $dep20 $dep10 | awk '{if(($1-$2)<=3) print $1+9; else if(($1-$2)<=10) print $1+2; else print $1+($1-$2)*0.05}' | awk '{print int($1+1)}'`
    makecpt -T${dep1}/${dep2}/0.05 -C$cpt0  -D -Z -I > $cptd
    echo "depths are : "$dep10 $dep20 $dep1 $dep2

awk -v t=$tt -v l=$dt0 -v m=$mag3 '$6-t<l-5e-5 && $5>=m {print $3,$2,$4,10**($5/5-2.02)}' $inp1 | psxy -R -J -O -K -Sdi -C$cptd -W0.75p/255 >> $fig.ps
awk -v t=$tt -v l=$dt0 -v m=$mag3 '$6-t>+5e-5 && $5>=m {print $3,$2,$4,10**($5/5-2.02)}' $inp1 | psxy -R -J -O -K -Ssi -C$cptd -W0.75p/255 >> $fig.ps
awk -v t=$tt -v l=$dt0 -v m=$mag3 '$6-t>=l-5e-5 && $6-t<=5e-5 && $5>=m {print $3,$2,$4,10**($5/5-2.02)}' $inp1 | psxy -R -J -O -K -Sci -C$cptd -W0.75p/255 >> $fig.ps
psmeca -R -J -O -K -Sm0.12i/-10 -Z$cptd -W0.2p/0 -T0 gcmt_$i >> $fig.ps
psxy -R -J -O -K -Sa0.2i -W1p/255/0/0 >> $fig.ps << EOD
$evlon $evlat
EOD
echo $evlon $evlat 0 $dist1 $dist1 | psxy -R -J -O -K -SE -W1p/255/255/255 >> $fig.ps

awk -v i=$iseq '$1==i {print $11,$12}' $inp | psxy -R -J -O -K -Sa0.2i -W1p/55 >> $fig.ps 
awk -v i=$iseq '$1==i {print $11,$12,"0.0",2*10**(-2.44+0.59*$14),2*10**(-2.44+0.59*$14)}' $inp | psxy -R -J -O -K -SE -W0.75p/255/0/255 >> $fig.ps 

ss=`echo $dep2 $dep1 | awk '{print $1-$2}' | awk '{if($1>=450) print "100";else if($1>=200) print "50"; else if($1>=150) print "30"; else if($1>=90) print "20"; else if ($1>40) print "10"; else if ($1>=20) print "5"; else if ($1>=14) print "3"; else print "2"}'`
    gmtset ANNOT_FONT_SIZE 12p LABEL_FONT_SIZE 13p
    pslegend -R -J -Dx0i/-0.9i/${scale}i/0.55i/BL -C0.1i/0.1i -L1.2 -O -K << EOF >> $fig.ps
G -0.05i
B  $cptd 0.15i 0.07i -Ba${ss}:"Source Depth (km)": -E
EOF

    gmtset ANNOT_FONT_SIZE 14p LABEL_FONT_SIZE 14p
    pscoast -R0/360/${lat11}/${lat22} -B60wsne -Dc -G240/220/160 -W0.2p/0 -O -K -Y3.75i -JM5.5i -X4.4i >> $fig.ps
    awk '$2==1 {print $5,$6}' $inp | psxy -R -J -O -K -Sc0.04i -W0.2p/255 -G0/0/250 >> $fig.ps
    echo $evlon $evlat | psxy -R -J -O -K -Sc0.1i -W0.4p/0 -G255/0/0 >> $fig.ps

###### Time sequence

nnevt=`awk -v t=$tt -v l=$dt0 '$6-t>=l-5e-5 && $6-t<=5e-5 {print $0}' $inp1 | wc | awk '{print $1-2}'`
echo $nnevt "############"
trange=${t1}/${t2}/${mag3}/9.5

gmtset TICK_LENGTH 0.125c
psbasemap  -R$trange -JX6.3i/3.75i -G200 -Ba5f1:"Days from the Mainshock":/a1f0.5:"Magnitude":WS -K -O  -Y-4i >> $fig.ps
psxy -M -R -J -O -K -W0.2p/0/0/0t3:3_0 >> $fig.ps << EOD
>
$t1 $mag1
$t2 $mag1
>
$t1 5.5
$t2 5.5
>
$t1 7.0
$t2 7.0
>
0 $mag3
0 9.5
>
$dt0 9.5
$dt0 2.5
EOD


awk -v t=$tt -v l=$dt0 '$6-t<l-5e-5 {print $6-t,$5,$4,10**($5/5-2.02)}' $inp1 | sort -n -rk 4 | psxy -R -J -O -K -Sdi -W0.75p/255 -C$cptd >> $fig.ps
awk -v t=$tt -v l=$dt0 '$6-t>5e-5 {print $6-t,$5,$4,10**($5/5-2.02)}' $inp1 | sort -n -rk 4 | psxy -R -J -O -K -Ssi -W0.75p/255 -C$cptd >> $fig.ps
awk -v t=$tt -v l=$dt0 '$6-t>=l-5e-5 && $6-t<=5e-5 {print $6-t,$5,$4,10**($5/5-2.02)}' $inp1 | sort -n -rk 4 | psxy -R -J -O -K -Sci -W0.75p/255 -C$cptd >> $fig.ps
awk -v t=$tt 'NR>1 {print $16-t,$14,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12}' gcmt_$i | psmeca -R -J -O -K -N -Sm0.12i/-10  -Z$cptd -W0.2p/0 -T0 >> $fig.ps
psxy -R -J -O -K -Sa0.2i -W1p/255/0/0 >> $fig.ps << EOD
0.0 $magg
EOD
awk -v i=$iseq '$1==i {print -$16,$14}' $inp| psxy -R -J -O -K -Sa0.15i -W1p/55 >> $fig.ps 



awk -v i=$iseq -v w=$t1 -v n=$ievt '$1==i {print w+1,"9.25 12 0 1 LM ",n+1". "$3,$4,"M"$8,"H="$7"km"}' $inp | pstext -R -J -O -K -N -G255/0/0 >> $fig.ps 
awk -v i=$iseq -v w=$t1 -v n=$ievt '$1==i {print w+1,9.25-$2*0.35," 12 0 1 LM ",n-$2+1". "$9,$10,"M"$14,"H="$13"km, @~D@~D="$15" km"}' $inp | pstext -R -J -O -K -N >> $fig.ps 


pwd | psxy -R -J -O -H >> $fig.ps
cat $fig.ps >> $fig0.ps
rm $fig.ps tmp
rm $inp1
done
ps2pdf ${fig0}.ps 
evince ${fig0}.pdf &
rm ${fig0}.ps
