  program randomize
  implicit none
  integer :: n1,nyear,nevt,i,nn
  parameter (nn=101000)

  character*50 tim(nn),inpfil,oupfil,nam(nn)
  real(kind=4) :: lat(nn),lon(nn), dep(nn),mag(nn)
  real(kind=8) :: dat(nn),dd,dat1(nn)
  
  write(*,*) "Input catalog, EQ number and range of random: "
  read(*,*) inpfil, nevt, nyear
  print *, int(nyear/4),365*nyear+int(nyear/4)
  open(5,file=inpfil)
  n1=len_trim(inpfil)
  oupfil=inpfil(1:n1)//".rand"
  open(65,file=oupfil)

  call init_random_seed()
  do i=1,nevt
     read(5,*) tim(i),lat(i),lon(i),dep(i),mag(i),dat(i),nam(i)
     call random_number(dd)
     dat1(i)=dat(i)+(dd-0.5)*(365*nyear+int(nyear/4))
     write(65,23) tim(i),lat(i),lon(i),dep(i),mag(i),dat1(i),nam(i),dat(i),dd
  enddo
  close(5)
  close(65)
23 Format(A24,2f8.3,2f7.1,f16.8,"   ",A30,2f16.8)


  end

  subroutine init_random_seed()
  integer :: i, n, clock
  integer, dimension(1), allocatable :: seed(:)

  call random_seed(size = n)
  allocate(seed(n))

  call system_clock(count=clock)

  seed = clock + 37 * (/ (i - 1, i = 1, n) /)
  call random_seed(put = seed)

  deallocate(seed)
end subroutine init_random_seed

